/**
 * Common Libraries and Defined Constants
 * */

#ifndef __COMMON_H__
#define __COMMON_H__

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

/* ERROR CODES */

enum
{
	SUCCESS,
	SEMGET_ERROR,
	SEMCTL_ERROR,
	FORK_ERROR,
	SEMOP_ERROR,
	FAILURE
};

/* COLORED OUTPUT */

#define RED "\033[0;31m"
#define CYAN "\033[0;36m"
#define GREEN "\033[0;32m"
#define BLUE "\033[0;34m"
#define FLUSH "\033[0m"

/* CONSTANTS */

#define N_PLAYERS 6	     /* Number of Players */
#define N_ROUNDS 10	     /* Number of Rounds */
#define N_SEMS N_PLAYERS + 2 /* Number of Semaphores */
#define KEY_LEN 20	     /* Maximum length of the IPC key */

/* SEMAPHORE STRUCTURE */

union semun
{
	int val;
	struct semid_ds *buf;
	unsigned short *array;
};

struct sembuf acquire = {0, -1, SEM_UNDO},
	      release = {0, 1, SEM_UNDO};

enum
{
	READY,
	START,
	P0,
	P1,
	P2,
	P3,
	P4,
	P5
};

#endif /*	__COMMON_H__	*/